//@author: antokhio
//@help: template for standard shaders
//@tags: template
//@credits: 

//StructuredBuffer<float4> color <bool color=true;>;

Texture2DArray tex;
SamplerState s0:IMMUTABLE {Filter=MIN_MAG_MIP_LINEAR;AddressU=CLAMP;AddressV=CLAMP;};

//float4x4 tW : WORLD;
float4x4 tVP : VIEWPROJECTION;

StructuredBuffer<float4x4> tW;

struct VS_IN
{
	float4 pos : POSITION;
	float4 uv : TEXCOORD0;
	uint ii : SV_InstanceID;
};

struct VS_OUT
{
    float4 pos: SV_POSITION;
    float4 uv: TEXCOORD0;
	uint ii : SV_InstanceID;
};

VS_OUT VS(VS_IN input)
{
    VS_OUT output = (VS_OUT)0;
    output.pos  = mul(input.pos,mul(tW[input.ii],tVP));
    output.uv = input.uv;
	output.ii = input.ii;
    return output;
}

float4 PS(VS_OUT input): SV_Target
{
    float4 col = tex.Sample(s0,float3 (input.uv.xy,input.ii));
    return col;
}

technique10 Template
{
	pass P0
	{
		SetVertexShader( CompileShader( vs_4_0, VS() ) );
		SetPixelShader( CompileShader( ps_4_0, PS() ) );
	}
}




